#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <stdlib.h>

#include <unistd.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <arpa/inet.h>

#include <wiringPi.h>

#include "SMS_UDP_Definitions.hpp"

int sockfd_udp_cli;

void intHandler(int dummy)
{
	close(sockfd_udp_cli);
	exit(0);
}

int main(int argc, char** argv)
{
	signal(SIGINT, intHandler);
	
	if( wiringPiSetup() < 0 )
	{
		return 1;
	}
	
	puts("\nLocoField SLI\n");

	char udp_recvbuff[SMS_UDP_MAX_PACKETSIZE];
	PacketBase packetHeader;
	memset(&packetHeader, 0, sizeof(packetHeader));

	sockfd_udp_cli = socket(AF_INET, SOCK_DGRAM, 0);
	if( sockfd_udp_cli < 0 )
	{
		puts("ERROR: create socket.\n");
		return 1;
	}
	
	//int flags = fcntl(sockfd_udp_cli, F_GETFL, 0);
	//fcntl(sockfd_udp_cli, F_SETFL, flags | O_NONBLOCK);
	
	struct timeval timeout;      
    timeout.tv_sec = 1;
    timeout.tv_usec = 0;
	setsockopt(sockfd_udp_cli, SOL_SOCKET, SO_RCVTIMEO, (char*)&timeout, sizeof(timeout));

	
	sockaddr_in receiver;
	receiver.sin_family = AF_INET;
	receiver.sin_addr.s_addr = INADDR_ANY;
	receiver.sin_port = htons(SMS_UDP_PORT);

	int retval = bind(sockfd_udp_cli, (sockaddr*) &receiver, sizeof(receiver));
	if( retval < 0 )
	{
		puts("ERROR: bind socket.\n");
		return 1;
	}
	
	
	sTelemetryData data1;
	memset(&data1, 0, sizeof(data1));
	
	while( 1 )
	{
		retval = recvfrom(sockfd_udp_cli, (char*)&udp_recvbuff, sizeof(udp_recvbuff), 0, NULL, 0);	
		if( retval > 0 )
		{
			memcpy(&packetHeader, udp_recvbuff, sizeof(PacketBase));
			switch( packetHeader.mPacketType )
			{
			case eCarPhysics:
			{
				memcpy(&data1, udp_recvbuff, sizeof(data1));
			}
			default:
				continue;
			}
		}
	}

	intHandler(0);
	return 0;
}
